<script>
import debounce from 'lodash/debounce';
import { GlSafeHtmlDirective as SafeHtml } from '@gitlab/ui';
import { WORKFLOW_STARTED } from '../../../constants';
import StepStatusBadge from './step_status_badge.vue';
import CheckpointSkeletonLoader from './checkpoint_skeleton_loader.vue';
import { isTerminated } from '../../../../common/duo_workflow_status';
import { renderDuoChatMarkdownPreview } from '../../../utils/markdown_renderer';

export default {
  name: 'DuoWorkflowCheckpoints',
  components: {
    CheckpointSkeletonLoader,
    StepStatusBadge,
  },
  directives: {
    SafeHtml,
  },
  props: {
    checkpoint: {
      type: Object,
      required: true,
    },
    hasAcceptedPlan: {
      type: Boolean,
      required: false,
      default: false,
    },
    status: {
      type: String,
      required: true,
    },
  },
  computed: {
    currentStep() {
      const activeStep = this.steps.find((step) => step.status !== 'Completed');
      const index = this.steps.indexOf(activeStep);

      // Is in planning phase. Once we have the running status on active steps,
      // we can simply show this active step based on the `RUNNING` status
      if (isTerminated(this.status) || (index === 0 && !this.hasAcceptedPlan)) return null;

      return activeStep;
    },
    isLoading() {
      return this.steps.length === 0 && !isTerminated(this.status);
    },
    steps() {
      const steps = this.checkpoint?.channel_values?.plan?.steps || [];
      return steps.map(this.formatStep);
    },
  },
  methods: {
    formatTestId(step) {
      return this.isCurrentStep(step) ? 'active-step' : '';
    },
    formatStep(step) {
      return {
        ...step,
        description: renderDuoChatMarkdownPreview(step.description),
      };
    },
    isCurrentStep(step) {
      return this.currentStep && step.description === this.currentStep.description;
    },
  },
  currentStepCss: 'gl-rounded-lg selected-item',
};
</script>
<template>
  <div class="gl-mt-3">
    <checkpoint-skeleton-loader v-if="isLoading" />
    <ul v-else class="gl-list-style-none gl-pl-0 gl-text-sm gl-max-w-limited">
      <li
        class="gl-flex gl-p-3"
        :class="isCurrentStep(step) ? $options.currentStepCss : ''"
        v-for="step in steps"
        :key="step.id"
        :data-testid="formatTestId(step)"
      >
        <div>
          <step-status-badge :status="step.status" :isActiveStep="isCurrentStep(step)" />
        </div>
        <div class="gl-px-3 overflow-text">
          <span v-safe-html="step.description" class="gl-markdown"></span>
        </div>
      </li>
    </ul>
  </div>
</template>
